<?php
	define(CLOAKME_PROFILES,'cloakme_profiles');
	define(CLOAKME_GLOBALS,'cloakme_options');
	define('CLOAKME_URLPATH', WP_PLUGIN_URL.'/'.plugin_basename( dirname(__FILE__) ).'/' );
	if ( !defined('ABSPATH') )
	define('ABSPATH', dirname(__FILE__) . '/');

	
	//ADD BUTTON TO TINYMCE
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	class cloakme_post_shortcode_button 
	{
		var $pluginname = "cloakme";

		function cloakme_post_shortcode_button()  {
			// Modify the version when tinyMCE plugins are changed.
			add_filter('tiny_mce_version', array (&$this, 'change_tinymce_version') );
			
			// init process for button control
			add_action('init', array (&$this, 'add_buttons') );
		}

		function add_buttons() {
			// Don't bother doing this stuff if the current user lacks permissions
			if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;
			
			// Add only in Rich Editor mode
			if ( get_user_option('rich_editing') == 'true') {
				// add the button for wp2.5 in a new way
				add_filter("mce_external_plugins", array (&$this, "add_tinymce_plugin" ), 5);
				add_filter('mce_buttons', array (&$this, 'register_button' ), 5);
			}
		}
		
		// used to insert button in wordpress 2.5x editor
		function register_button($buttons) {
			array_push($buttons, "separator", $this->pluginname );
			return $buttons;
		}
		
		// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
		function add_tinymce_plugin($plugin_array) {    
			$plugin_array[$this->pluginname] =  CLOAKME_URLPATH.'tinymce/editor_plugin.js';
			return $plugin_array;
		}
		
		function change_tinymce_version($version) {
			return ++$version;
		}
	}
	
	$tinymce_button = new cloakme_post_shortcode_button();	
	
	//ACTIVATION / CREATE TABLES
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	
	function cloakme_activate() {
	   global $wpdb;	
	   
		
		if ( !empty($wpdb->charset) )
			$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
		
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}wptt_cloakme_profiles (
			id INT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
			classification_prefix VARCHAR(255) NOT NULL,
			permalink VARCHAR(255) NOT NULL UNIQUE,
			cloaked_url VARCHAR(255) NOT NULL,
			redirect_url VARCHAR(255) NOT NULL,			
			redirect_spider INT(10) NOT NULL,
			redirect_method VARCHAR(10) NOT NULL,
			redirect_type VARCHAR(10) NOT NULL,
			blank_referrer INT(10) NOT NULL,
			cloak_target INT(10) NOT NULL,
			stuff_cookie VARCHAR(255) NOT NULL,
			visitor_count INT(10) NOT NULL,
			spider_count INT(10) NOT NULL,
			keywords MEDIUMTEXT NOT NULL,
			keywords_affect INT(1) NOT NULL,
			keywords_limit INT(2) NOT NULL,
			keywords_limit_total INT(2) NOT NULL,
			keywords_target_page VARCHAR(7) NOT NULL,
			type VARCHAR(20) NOT NULL
			) {$charset_collate};";
	
		$result = $wpdb->get_results($sql, ARRAY_A);
		
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}wptt_cloakme_logs (
				id INT(10) NOT NULL AUTO_INCREMENT PRIMARY KEY,
				permalink VARCHAR(225) NOT NULL,
				referrer VARCHAR(225) NOT NULL UNIQUE,
				count INT(10) NOT NULL
				) {$charset_collate};";
	
		$result = $wpdb->get_results($sql, ARRAY_A);
		
		
		$sql = "CREATE TABLE IF NOT EXISTS {$wpdb->prefix}wptt_cloakme_options (
			id INT(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
			option_name VARCHAR(255) NOT NULL,
			option_value TEXT NOT NULL,
			status INT(2) NOT NULL
			) {$charset_collate};";
		
		$result = $wpdb->get_results($sql, ARRAY_A);			
			
		//generate the new htaccess code
		$newcode = "#wp-traffic-tools-start
<IfModule mod_rewrite.c>
RewriteEngine On
RewriteRule ^(.*)images/special-(.*)\.gif$ $1drop_insurance.php?url=$2 [R=301,L]
RewriteRule ^(.*)images/special-blank-(.*)\.gif$ $1drop_insurance.php?blank=1&url=$2 [R=301,L]  \n
RewriteRule ^(.*)go/(.*)$ ".ABSPATH."/wp-content/plugins/wp-traffic-tools/relay.php?permalink=$2 [L] \n
</IfModule> \n
#wp-traffic-tools-end";

			
		//fopen .htacess
		$targetFile = ABSPATH.".htaccess"; 
		$handle = fopen($targetFile, "a+"); 
		$data = fread($handle,filesize($targetFile)); 
		fclose($handle);
		
		if (!strstr($data,'#wp-traffic-tools-start'))
		{
			if (strstr($data, '# BEGIN WordPress'))
			{
				$data = str_replace('# BEGIN WordPress', $newcode."\n\n", $data);
				$handle = fopen($targetFile, "w");
				$htaccess = $data;
				fwrite($handle, $htaccess);
				fclose($handle);
			}
			else
			{
				$handle = fopen($targetFile, "w");
				$htaccess = "$data \n $newcode";
				fwrite($handle, $htaccess);
				fclose($handle);
			}
		}
		
	}
	
	//ADD MENU ITEM AND OPTIONS PAGE
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	//*****************************************
	function cloakme_add_javascript()
	{
		?>
			<!-- Support for the delete button , we use Javascript here -->
			
			<script type="text/javascript">
				function js_cloakme_delete(profile_id)
				{
				   if (confirm('Are you sure you want to delete this profile?'))
					 {
					   document.cloakme_profile_add.action.value = 'delete';
					   document.cloakme_profile_add.profile_id.value = profile_id; 
					   document.cloakme_profile_add.submit();
					 }
				} 
			
				
				jQuery(document).ready(function() 
				{
					jQuery('.class_profile_save_profile').attr('class','class_cloaking_edit_profile');
					jQuery('.class_save_profile').attr('class','class_add_profile');
					
					jQuery('.class_profile_save_profile').live("click" ,function() {
						//alert(1);
						jQuery('#id_cloaking_form_nature').val('cloaking_save_profile');
						jQuery("#id_cloaking_cloakme_form").submit();
					});
					
					jQuery('.class_save_profile').live("click" ,function() {
						//alert(1);
						jQuery('#id_cloaking_form_nature').val('cloaking_save_profile');
						jQuery("#id_cloaking_cloakme_form").submit();
					});
					
					
					jQuery('.class_add_profile').live("click",function() {
						jQuery(".class_tr_row").hide();
						jQuery('.class_profile_save_profile').attr('value','Edit');
						jQuery('.class_profile_save_profile').attr('class','class_cloaking_edit_profile');
						jQuery('#id_row_last_header').show();
						jQuery('#id_row_last').show();						
						jQuery(".class_tr td:eq(2)").html('<br><br><center><img src="<?php echo CLOAKME_URLPATH;?>images/ajax-loader.gif"></center><br><br>');
						jQuery.get('<?php echo CLOAKME_URLPATH; ?>ajax.php?mode=links&id=x', function(data) {
						   jQuery('#id_row_last').html(data);
						   jQuery('.class_add_profile').text('Save');
						   jQuery('.class_add_profile').attr('class','class_save_profile');
						});						
					});
					
					
					
					jQuery('.class_cloaking_edit_profile').live("click" ,function() {
						var id = this.id.replace('id_cloaking_edit_profile_','');
						
						//hide add new profile
						jQuery("#id_row_last").html('<td></td><td colspan=5><br><br><center><img src="<?php echo CLOAKME_URLPATH;?>images/ajax-loader.gif"></center><br><br></td>');
						jQuery("#id_row_last").hide();
						jQuery("#id_row_last_header").hide();
						jQuery('.class_save_profile').text('Click Here to Add New Profile');
						jQuery('.class_save_profile').attr('class','class_add_profile');
						
						//change other editing boxes back to normal
						jQuery('.class_profile_save_profile').attr('value','Edit');
						jQuery('.class_profile_save_profile').attr('class','class_cloaking_edit_profile');
						jQuery(".class_tr_row").html('<td></td><td colspan=5><br><br><center><img src="<?php echo CLOAKME_URLPATH;?>images/ajax-loader.gif"></center><br><br></td>');
						jQuery(".class_tr_row").hide();
						
						//change current button 
						jQuery('#id_cloaking_edit_profile_'+id).attr('value','Save');
						jQuery('#id_cloaking_edit_profile_'+id).attr('class','class_profile_save_profile');
						
					
						jQuery("#id_tr_row_"+id).show();
						jQuery.get('<?php echo CLOAKME_URLPATH; ?>ajax.php?mode=links&nature=edit&id='+id, function(data) {
							jQuery(".class_tr_row").html('<td></td><td colspan=5><br><br><center><img src="<?php echo CLOAKME_URLPATH;?>images/ajax-loader.gif"></center><br><br></td>');
							jQuery("#id_tr_row_"+id).html(data);
						});

					});
					
					jQuery('#save_ajax').click(function() { 
						jQuery.post('<?php echo CLOAKME_URLPATH; ?>ajax.php?mode=links&nature=save&id='+id,  jQuery("#id_cloaking_cloakme_form").serialize(), function(data) {
						 var id = data;
						 alert(id);
						 jQuery('#id_cloaking_save_profile_ajax').attr('value','Edit');
						 jQuery('#id_cloaking_save_profile_ajax').attr('id','#id_cloaking_edit_profile_'+id);
					   });	
						
					});
					
					jQuery('#id_cloaking_save_cloaking').click(function() {
						jQuery('#id_classifications_form_nature').val('cloaking_save_cloaking');
						jQuery("#id_form_classifications").submit();
					});
					
					jQuery('#id_cloaking_add_classification_prefix').click(function() {
						var html = '<tr><td><label for=keyword>Redirect Classification</label></td><td><input name="classification_prefix[]" value="" /> <img  onClick=\'jQuery(this).parent().parent().remove();\' src=\'<?php echo CLOAKME_URLPATH; ?>remove.png\' style=\'cursor:pointer;\'></td></tr>';
						jQuery("#id_cloaking_classification_prefixes tr:last").after(html);
	
					});

					jQuery('.class_cloaking_delete_profile').click(function() {
						var id = this.id.replace('id_cloaking_delete_profile_','');
						jQuery('#id_cloaking_form_nature').val('cloaking_delete_profile');
						jQuery('#id_cloaking_profile_id').val(id);
						jQuery("#id_cloaking_cloakme_form").submit();
					});
				});
				


			</script>
		<?php
	}
	
	function cloakme_settings()
	{
		global $table_prefix;
		
		/* Retrieve the profile data */ 
		$query = "SELECT * FROM {$table_prefix}wptt_cloakme_profiles WHERE type='affiliate'";
		$result = mysql_query($query);
		while ($arr = mysql_fetch_array($result))
		{
			$cloaking_profile_id[] = $arr['id'];
			$cloaking_classification[] = $arr['classification_prefix'];
			$cloaking_permalink[] = $arr['permalink'];			
			$cloaking_cloaked_url[] = $arr['cloaked_url'];
			$cloaking_redirect_url[] = $arr['redirect_url'];
			$cloaking_spider_count[] = $arr['spider_count'];
			$cloaking_visitor_count[] = $arr['visitor_count'];
		}
		
		/* Retrieve the global settings */ 
		$query = "SELECT `option_value` FROM wpt_classification_prefixes  WHERE option_name='classification_prefix'";
		$result = mysql_query($query);
		if (!$result){echo $query; echo mysql_error(); exit;}
		$arr = mysql_fetch_array($result);
		$cloaking_classification_prefix =$arr[option_value];
		$cloaking_classification_prefix = explode(';',$cloaking_classification_prefix);
		//echo $classification_prefix;exit;		
		
		?>
		<br>
		<h3>Classification Categories</h3>
 		<a name="keywordeditor"></a>
		
		<form name=cloakme_classification id='id_form_classifications' method="post" action="?page=wp-traffic-tools/wp-traffic-tools.php&tab_display=1">
		<input type=hidden name=this_action value=save >
		<input type=hidden name=nature id='id_classifications_form_nature' value='cloaking_save_classification' >
		<table>
			
			<tr>
				<td colspan=2>
						<table id='id_cloaking_classification_prefixes'>
							
							<?php
								if (count($cloaking_classification_prefix)>1)
								{
									foreach ($cloaking_classification_prefix as $k=>$v)
									{
										$i=$k+1;
								?>
										<tr>
											<td width='230'>
													Redirect Classification <?php echo $i; ?>
											</td>
											<td>
													<input  name='classification_prefix[]' <?php echo "value='$cloaking_classification_prefix[$k]'"; ?> />
													<?php
														if ($k==0)
														{
															?>
															<img src='<?php echo CLOAKME_URLPATH; ?>images/add.png' style='cursor:pointer' id='id_cloaking_add_classification_prefix' title='add more classifications'><i><font style='font-size:9px;'>eg; http://www.myblog.com/<b>go</b>/custom-permalink</font></i>
															<?php
														}
														else
														{
															?>
															<img  onClick='jQuery(this).parent().parent().remove();' src='<?php echo CLOAKME_URLPATH; ?>images/remove.png' style='cursor:pointer;'>
															<?php
														}
													?>
													
											</td>
										</tr>
								<?php
									}
								}
								else
								{
									?>
									<tr>
										<td width='230'>
												Redirect Classification 1:
										</td>
										<td>
												<input   name='classification_prefix[]' <?php if (!$cloaking_classification_prefix[0]){ echo 'value="Go"'; } else { echo "value='$cloaking_classification_prefix[0]'"; }?> /> <img src='<?php echo CLOAKME_URLPATH; ?>images/add.png' style='cursor:pointer' id='id_cloaking_add_classification_prefix' title='add more classifications'>
													<i><font style='font-size:9px;'>eg; http://www.myblog.com/<b>go</b>/custom-permalink</font></i>
								
												
										</td>
									</tr>
							<?php
							}
							?>
						</table>
				
				</td>
			</tr>
			<tr>
				<td valign=top colspan=2>
					<br>
				</td>
			</tr>
			<tr>
				<td>
					<button style='background-color:#1E90FF;border-style:solid;border-width:1px;padding:2px;border-color:#000000;color:#fff;cursor:pointer;font-size:11px;' type=submit id='id_cloaking_save_cloaking' name='save_cloaking' value="Save" >Save Settings</button>
				</td>
			</tr>
		</table>
		</form>
		<br><br>
		<form name=cloakme_profile_add id='id_cloaking_cloakme_form' method="post" action="?page=wp-traffic-tools/wp-traffic-tools.php&tab_display=1">
		<input type=hidden name=this_action value=save >
		<input type=hidden name=nature id='id_cloaking_form_nature' value=cloaking_save_profile >
		<input type=hidden name=profile_id id='id_cloaking_profile_id' value='' >
		
		
		<?php
		
		 echo "<h3>Link Profiles</h3>";
		 
		 if ($cloaking_profile_id)
		 { 
			echo "<table class='widefat' style='width:100%' id='id_table_link_profiles'>\n";		 	  
			echo "<tr><thead><tr><th>#</th>";
			echo "<th>Cloaked URL</th>";
			echo "<th>Affiliate URL</th>";
			echo "<th>Human Visits</th>";
			echo "<th>Spider Visits</th>";
			echo "<th>Actions</th>";
			echo "</tr></thead>\n";
		
			$cnt = 1;
			foreach ($cloaking_profile_id as $key=>$val) 
			{				 
				echo '<tr>';
				echo "<td>$cnt";
				echo "</td>";
				
				echo "<td id='id_cloaking_profile_cloaked_url_$key'><a href='$cloaking_cloaked_url[$key]'>$cloaking_cloaked_url[$key]</a></td>";
				echo "<td width='260'><a href='$cloaking_redirect_url[$key]'>$cloaking_redirect_url[$key]</a></td>";
				echo "<td ><a href='".CLOAKME_URLPATH."wp-show-logs.php?permalink={$cloaking_permalink[$key]}' target='_blank'> $cloaking_visitor_count[$key]</a></td>";
				echo "<td >$cloaking_spider_count[$key]</td>";
				 
				
				echo "<td><input type=button value=Edit  id='id_cloaking_edit_profile_$val' class='class_cloaking_edit_profile'>";
				echo "<input type=button value=Delete  id='id_cloaking_delete_profile_$val' class='class_cloaking_delete_profile'>";
				echo "</td></tr>\n";
				
				echo "<tr id='id_tr_row_$val' style='display:none;background-color:GhostWhite;' class='class_tr_row'><td></td><td colspan=4>";
				?>
					<br><br>
					<center><img src='<?php echo CLOAKME_URLPATH;?>images/ajax-loader.gif'></center>
					<br><br>
				<?php
				echo '</td></tr>';
				$cnt++;
				
			}
			echo '<tr id="id_row_last_header" style="display:none"><td colspan=6><h4>Add New Profile</h4></td></tr>';
			echo "<tr id='id_row_last' style='display:none'>
					<td colspan=6>
						<center><img src='".CLOAKME_URLPATH."images/ajax-loader.gif'></center>
						<br><br>
					</td>
				</tr>
				<tr>
					<td colspan=6 align=right>
						<br>
						<button style='background-color:#1E90FF;border-style:solid;border-width:1px;padding:2px;border-color:#000000;color:#fff;cursor:pointer;font-size:11px;width:100px' type='button' id='id_cloaking_add_profile' class='class_add_profile'>Click Here to Add New Profile</button>
						<br><br>
					</td>
				</tr></table>";
		 }
		 else
		 {
		 	 echo "<p><i>no profiles found</i></p>";
			 $key=0;
			 ?>
			 <table class='widefat' style='width:100%' id='id_table_link_profiles'>
				<tr id="id_row_last_header" style="display:none">
					<td colspan=6><h4>Add New Profile</h4>
					</td>
				</tr>
				<tr id='id_row_last' style='display:none'>
					<td colspan=6>
						<center><img src='<?php echo CLOAKME_URLPATH; ?>images/ajax-loader.gif'></center>
						<br><br>
					</td>
				</tr>
				<tr>
					<td colspan=6 align='center'>
						<button style='background-color:#1E90FF;border-style:solid;border-width:1px;padding:2px;border-color:#000000;color:#fff;cursor:pointer;font-size:11px;width:100px' type='button' id='id_cloaking_add_profile' class='class_add_profile'>Add Profile</button>
						<br>
					</td>
				</tr>
			 </table>
			<?php
		 } 
		?>
		
		</form>
		
		
		<?php
		
	}

	
	function cloakme_update_settings()
	{
		
		global $table_prefix;
		$wordpress_url = get_bloginfo('url');
		
		if (substr($wordpress_url, -1, -1)!='/')
		{
			$wordpress_url = $wordpress_url."/";
		}
		
		if ($_POST['nature']=='cloaking_delete_profile')
		{
			$profile_id = $_POST['profile_id'] ;
			$query = "DELETE FROM {$table_prefix}wptt_cloakme_profiles  WHERE id='$profile_id'";
			$result = mysql_query($query);
			if (!$result) { echo $query; echo mysql_error(); }
		}
		if ($_POST['nature']=='cloaking_save_profile')
		{
			$profile_id = $_POST['profile_id'];
			$classification_prefix = $_POST['classification'];
			$permalink = $_POST['permalink'];
			$redirect_url = $_POST['redirect_url'];
			$blank_referrer = $_POST['blank_referrer'];
			$redirect_spider = $_POST['redirect_spider'];
			$redirect_method = $_POST['redirect_method'];
			$redirect_type = $_POST['redirect_type'];
			$cloak_target = $_POST['cloak_target'];
			$stuff_cookie = $_POST['stuff_cookie'];
			$keywords = addslashes($_POST['keywords']);
			$keywords_affect = $_POST['keywords_affect'];
			$keywords_limit = $_POST['keywords_limit'];
			$keywords_limit_total = $_POST['keywords_limit_total'];
			$keywords_target_page = $_POST['keywords_target_page'];
			
			//print_r($profile_id);exit;
			if ($profile_id&&$permalink)
			{	
				
				$permalink = sanitize_title_with_dashes($permalink);
				$cloaked_link = $wordpress_url.$classification_prefix."/".$permalink;
				if ($profile_id!='x')
				{
					$query = "UPDATE {$table_prefix}wptt_cloakme_profiles SET permalink='$permalink' , classification_prefix='$classification_prefix', cloaked_url='$cloaked_link', redirect_url='$redirect_url', blank_referrer='$blank_referrer', redirect_spider='$redirect_spider', redirect_method='$redirect_method', redirect_type='$redirect_type', cloak_target='$cloak_target', stuff_cookie='$stuff_cookie', keywords = '$keywords', keywords_affect = '$keywords_affect', keywords_limit = '$keywords_limit', keywords_limit_total = '$keywords_limit_total', keywords_target_page = '$keywords_target_page' WHERE id='$profile_id'";
					$result = mysql_query($query);
					if (!$result) { echo $query; echo mysql_error(); }
				}
				else
				{
					$query = "INSERT INTO {$table_prefix}wptt_cloakme_profiles (`id`,`classification_prefix`,`permalink`,`cloaked_url`,`redirect_url`,`blank_referrer`,`redirect_spider`,`redirect_method`,`redirect_type`,`cloak_target`,`stuff_cookie`,`visitor_count`,`spider_count`,`type`,`keywords`,`keywords_affect`,`keywords_limit`,`keywords_limit_total`,`keywords_target_page`) VALUES ('','$classification_prefix','$permalink','$cloaked_link','$redirect_url','$blank_referrer','$redirect_spider','$redirect_method','$redirect_type','$cloak_target','$stuff_cookie','0','0','affiliate','$keywords','$keywords_affect','$keywords_limit','$keywords_limit_total','$keywords_target_page')";
					$result = mysql_query($query);
					if (!$result) { echo $query; echo mysql_error(); }
				}
			}
			
			
			
		}
		else if ($_POST['nature']=='cloaking_save_cloaking')
		{
			$classification_prefix = $_POST['classification_prefix'];
			$classification_prefix = implode(';',$classification_prefix);
			$classification_prefix = strtolower($classification_prefix);
			
			$query = "UPDATE wpt_classification_prefixes SET option_value='$classification_prefix' WHERE option_name='classification_prefix'";
			$result = mysql_query($query);
			if (!$result) { echo $query; echo mysql_error();exit;}
			//rebuild htaccess
			
			// Adding a new rule
			global $wp_rewrite;
			$classification_prefix = explode(';',$classification_prefix);
			$rules = "";
			foreach ($classification_prefix as $k=>$v)
			{
				$v = trim($v);
				if ($v)
				{
					$rules[] = "RewriteRule ^(.*){$v}/(.*)$ ".ABSPATH."wp-content/plugins/wp-traffic-tools/relay.php?permalink=$2 [L]";
				}
			}

			
			//generate the new htaccess code
			$wp_rewrite->non_wp_rules = $array;
			$newcode_start = "#wp-traffic-tools-start \n
<IfModule mod_rewrite.c> 
RewriteEngine On
RewriteRule ^(.*)images/special-(.*)\.gif$ $1drop_insurance.php?url=$2 [R=301,L]  \n
RewriteRule ^(.*)images/special-blank-(.*)\.gif$ $1drop_insurance.php?blank=1&url=$2 [R=301,L]  \n";
			foreach($rules as $k=>$v)
			{
				$newcode .= "$v \n";
			}
			$newcode_end = "</IfModule> \n
#wp-traffic-tools-end";

			$newcode = $newcode_start.$newcode.$newcode_end;
			//echo $newcode;
			
			//fopen .htacess
			$targetFile = ABSPATH.".htaccess"; 
			$handle1 = fopen($targetFile, 'a+');  	
			$data = @fread($handle1,filesize($targetFile)); 
			fclose($handle1);
			$handle2 = fopen($targetFile, "w");
			//echo $data;exit;
			if (strstr($data,'#wp-traffic-tools-start'))
			{
			   
			   $data = preg_replace('/#wp-traffic-tools-start(.+)#wp-traffic-tools-end/msi', '***wptt***' , $data );
			   $data = str_replace('***wptt***',$newcode,$data);

			}
			else
			{
				if (strstr($data, '# BEGIN WordPress'))
				{
					$data = str_replace('# BEGIN WordPress', $newcode."\n\n # BEGIN WordPress", $data);
				}
				else
				{
					$data = $data."\n $newcode";
				}
				
			}
			
			
			
			fwrite($handle2, $data);
			fclose($handle2);
			//echo $data;exit;

			//echo 1; exit;

		}
	}
		
	function cloakme_options_page()
	{	
		/* Definition */
		echo '<div class="wrap">';

			
		/* Show the existing options */
		cloakme_settings();
			
			

		echo '</div>';
	}

    /*
	
	function cloakme_add_menu()
	{
		 // Add a page to the options section of the website
	   if (current_user_can('manage_options')) 				
			add_options_page("Cloak Me","Cloak Me", 8, __FILE__, 'cloakme_options_page');
	}
	

	//on activation
	register_activation_hook(__FILE__, 'cloakme_activate');
	add_action('admin_menu', 'cloakme_add_menu');
	*/
	
?>