<?php
class wpt_widgets_topsearches extends WP_Widget 
{
	/**
	 * Widget setup.
	 */
	function wpt_widgets_topsearches() 
	{
		$widget_ops = array( 'classname' => 'class_widget_topsearches', 'description' => 'This widget calls the top searches queries in a variety of ways. ');

		$this->WP_Widget( 'wpt_widgets_topsearches', 'WPTT: Topsearches','wpt_topsearhces', $widget_ops );
	}

	function widget( $args, $instance ) 
	{
		extract( $args );
		echo $before_widget;
		/* Our variables from the widget settings. */
		$title = apply_filters('widget_title', $instance['title'] );
					
		$limit = $instance['limit'];
		$display_count = $instance['display_count'];
		$nature = $instance['nature'];
		$sort = $instance['sort'];
		$link = $instance['link'];
		if ($display_count!=1){$display_count=0;}
		
		$content =  wpt_top_searches("[wpttopsearches:$nature:$sort:$limit:$display_count:$link]");
		
		if (strlen($content)>50)
		{
			if ( $title ) echo $before_title . $title . $after_title;
			echo $content;
		}
		echo $after_widget;
	}


	function update( $new_instance, $old_instance ) 
	{
		$instance = $old_instance;

		/* Strip tags for title and name to remove HTML (important for text inputs). */
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['limit'] =  $new_instance['limit'] ;
		$instance['display_count'] = $new_instance['display_count'];
		$instance['nature'] = $new_instance['nature'];
		$instance['sort'] = $new_instance['sort'];
		$instance['link'] = $new_instance['link'];
		
		return $instance;
	}

	function form( $instance ) 
	{

		/* Set up some default widget settings. */
		$defaults = array( 'title' => 'Recent Searches', 'limit' => '5', 'nature' => 'global', 'sort' => 'DESC', 'link' => '1',  'display_count' => '1' );
		$instance = wp_parse_args( (array) $instance, $defaults );
		$title = strip_tags($instance['title']);
		$limit = $instance['limit'];
		$nature = $instance['nature'];
		$sort = $instance['sort'];
		$link = $instance['link'];
		$display_count = $instance['display_count'];
		
		?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>">Title:</label>
			<input name="<?php echo $this->get_field_name('title'); ?>" id="<?php echo $this->get_field_id('title'); ?>" value="<?php echo $instance['title']; ?>" style="width:100%;" />
		</p>

		<p>
			<label for="<?php echo $this->get_field_id( 'nature' ); ?>">Widget Nature:</label> 
			<select id="<?php echo $this->get_field_id( 'nature' ); ?>" name="<?php echo $this->get_field_name( 'nature' ); ?>" class="widefat" style="width:100%;">
				<option value='single' <?php if ( 'single' == $instance['nature'] ) echo 'selected="selected"'; ?>>Top Page Queries</option>
				<option value='global' <?php if ( 'global' == $instance['nature'] ) echo 'selected="selected"'; ?>>Top Global Queries</option>
			</select>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'sort' ); ?>">Sorting:</label> 
			<select id="<?php echo $this->get_field_id( 'sort' ); ?>" name="<?php echo $this->get_field_name( 'sort' ); ?>" class="widefat" style="width:100%;">
				<option value='ASC' <?php if ( 'ASC' == $instance['sort'] ) echo 'selected="selected"'; ?>>By Search Count: ASC</option>
				<option value='DESC' <?php if ( 'DESC' == $instance['sort'] ) echo 'selected="selected"'; ?>>By Search Count: DESC</option>
				<option value='RAND' <?php if ( 'RAND' == $instance['sort'] ) echo 'selected="selected"'; ?>>Randomize</option>
			</select>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id('limit'); ?>">Limit:</label>
			<input name="<?php echo $this->get_field_name('limit'); ?>" id="<?php echo $this->get_field_id('limit'); ?>" value="<?php echo $instance['limit']; ?>" style="width:30px;" />
		</p>

		<p>
			<label for="<?php echo $this->get_field_id('link'); ?>">Link to Post:</label>
			<input  id="<?php echo $this->get_field_id('link'); ?>"  name="<?php echo $this->get_field_name('link'); ?>" class="checkbox" type="checkbox" <?php checked( $instance['link'], true ); ?> value='1'  /> 
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id('display_count'); ?>">Display Search Count:</label>
			<input  id="<?php echo $this->get_field_id('display_count'); ?>"  name="<?php echo $this->get_field_name('display_count'); ?>" class="checkbox" type="checkbox" <?php checked( $instance['display_count'], true ); ?> value='1'  /> 
		</p>

	<?php
	}
}
	
function global_add_javascript()
{
	global $global_topsearches;
?>
	<script type="text/javascript">				
		jQuery(document).ready(function() 
		{
			<?php
			if($global_topsearches==1)
			{
				echo "jQuery('.class_tr_topsearches_display').show(); \n";
			}
			else
			{
				echo "jQuery('.class_tr_topsearches_display').hide(); \n";
			}
			?>
			
			jQuery('#id_ts_1').click(function() {  
				jQuery('.class_tr_topsearches_display').show();
			});
			
			jQuery('#id_ts_0').click(function() {  
				jQuery('.class_tr_topsearches_display').hide();
			});
			
			jQuery('#id_global_save_setting').click(function() {
				jQuery('#id_global_form_nature').val('global_save_profile');
				jQuery("#id_global_form").submit();
			});
		});
	</script>
<?php
}

function global_update_settings()
{
	global $table_prefix; 
	//echo 1; exit;
	if ($_POST['nature']=='global_save_settings')
	{
		$ip_addresses = $_POST['ip_addresses'];
		$ip_addresses = nl2br($ip_addresses);
		//echo $ip_addresses; exit;
		$ip_addresses = explode('<br />', $ip_addresses);
		$ip_addresses = implode(';', $ip_addresses);
		
		$useragents = $_POST['useragents'];
		$useragents =  preg_split("/[\r\n,]+/", $useragents, -1, PREG_SPLIT_NO_EMPTY);
		$useragents = implode(';', $useragents);
		
		$global_cloak_link_profiles = $_POST['global_cloak_link_profiles'];
		$global_cloak_links = $_POST['global_cloak_links'];
		$global_cloak_links_pages = $_POST['global_cloak_links_pages'];
		$global_redirect_spiders = $_POST['global_redirect_spiders'];
		$global_nofollow_links = $_POST['global_nofollow_links'];
		$global_default_classification_prefix = $_POST['global_default_classification_prefix'];
		$global_keyword_affects = $_POST['global_keyword_affects'];
		$global_cloak_comments = $_POST['global_cloak_comments'];
		$global_cloak_commenter_url = $_POST['global_cloak_commenter_url'];
		$global_topsearches = $_POST['global_topsearches'];
		$global_topsearches_nature = $_POST['global_topsearches_nature'];
		$global_topsearches_header = $_POST['global_topsearches_header'];
		$global_topsearches_sort = $_POST['global_topsearches_sort'];
		$global_topsearches_limit = $_POST['global_topsearches_limit'];
		$global_topsearches_link = $_POST['global_topsearches_link'];
		$global_topsearches_display_count = $_POST['global_topsearches_display_count'];
		
		
		//echo $global_default_classification_prefix;
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$useragents' WHERE option_name='useragents'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$ip_addresses' WHERE option_name='ip_addresses'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_cloak_links' WHERE option_name='cloak_links'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_redirect_spiders' WHERE option_name='redirect_spiders'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_nofollow_links' WHERE option_name='nofollow_links'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_cloak_link_profiles' WHERE option_name='cloak_link_profiles'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_default_classification_prefix' WHERE option_name='default_classification_prefix'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_keyword_affects' WHERE option_name='keyword_affects'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_cloak_comments' WHERE option_name='cloak_comments'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_cloak_commenter_url' WHERE option_name='cloak_commenter_url'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches' WHERE option_name='topsearches'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_nature' WHERE option_name='topsearches_nature'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_header' WHERE option_name='topsearches_header'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_sort' WHERE option_name='topsearches_sort'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_limit' WHERE option_name='topsearches_limit'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_link' WHERE option_name='topsearches_link'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_topsearches_display_count' WHERE option_name='topsearches_display_count'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
		$query = "UPDATE {$table_prefix}wptt_wptraffictools_options SET option_value='$global_cloak_links_pages' WHERE option_name='cloak_links_pages'";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
	}
}

function global_options_page()
{
	global $table_prefix; 
	
	/* Get Classification prefixes */ 
		$query = "SELECT * FROM wpt_classification_prefixes WHERE option_name = 'classification_prefix' ";
		$result = mysql_query($query);
		if (!$result){echo $query; echo mysql_error(); exit;}
		
		$arr = mysql_fetch_array($result);
		$classification_prefix = $arr['option_value'];
		$classification_prefix = explode(';',$classification_prefix);

		/* Retrieve the global settings */ 
		$query = "SELECT `option_value` FROM {$table_prefix}wptt_wptraffictools_options  ORDER BY id ASC";
		$result = mysql_query($query);
		if (!$result){echo $query; echo mysql_error(); exit;}
		$count = mysql_num_rows($result);

		while ($array = mysql_fetch_array($result))
		{
		  $results[] = $array['option_value'];
		}

		//print_r($results);exit;
		$useragents = $results[0];
		$ip_addresses =$results[1];
		$global_cloak_links = $results[2];
		$global_redirect_spiders = $results[3];
		$global_nofollow_links = $results[4];
		$license_key = $results[5];
		$license_email = $results[6];
		$current_version = $results[7];
		$global_cloak_link_profiles = $results[8];
		$global_default_classification_prefix = $results[9];
		$global_keyword_affects = $results[10];
		$global_cloak_comments = $results[11];
		$global_cloak_commenter_url = $results[12];
		$global_topsearches = $results[13];
		$global_topsearches_nature = $results[14];
		$global_topsearches_header= $results[15];
		$global_topsearches_sort= $results[16];
		$global_topsearches_limit = $results[17];
		$global_topsearches_link = $results[18];
		$global_topsearches_display_count = $results[19];
		$global_cloak_links_pages = $results[20];

		//echo $global_cloak_links;exit;
		
		//echo $classification_prefix;exit;
		$ip_addresses = explode(';',$ip_addresses);
		$ip_addresses = implode('',$ip_addresses);
		$useragents = explode(';',$useragents);
		$useragents = implode("\n",$useragents);
	
	?>
	<div class="wrap">
		<h3>Global Settings</h3>
			<a name="keywordeditor"></a>
			<form name=global id='id_global_form' method="post" action="?page=wp-traffic-tools/wp-traffic-tools.php&tab_display=5">
			<input type=hidden name=nature id='id_global_form_nature' value=global_save_settings >
			<table class='class_global_settings_td'>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Turning this setting on will auto-detect occurences of links that we have link profiles set-up on, and convert those links to their custom-permalink format. Typically we would leave this on. These settings are applied to our RSS feeds as well as post/page content. "> 
							Auto-cloak our link profiles?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_cloak_link_profiles'  value=1 <?php if ($global_cloak_link_profiles==1){ echo 'checked="checked"'; } ?>> Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_cloak_link_profiles'  value=0 <?php if ($global_cloak_link_profiles!=1){ echo 'checked="checked"'; } ?>> No
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Turning this setting on will auto-cloak ALL links including (both) user-created link profiles and links that do not have user-created profiles. This feature will not cloak links pointing to internal pages. These settings are applied to our RSS feeds as well as post/page content. "> 
							Turn on sitewide link cloaking?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_cloak_links' <?php if ($global_cloak_links==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_cloak_links' <?php if ($global_cloak_links!=1){ echo 'checked="checked"'; } ?> value=0 > No
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="This feature will enable or disable global link cloaking and keyword affects for pages and the homepage, leaving them only enabled for posts. Sitewide llink cloaking and keyword affects must be enabled for this setting to have any affect."> 
							Enable sitewide link cloaking & keyword affects on posts only?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_cloak_links_pages' <?php if ($global_cloak_links_pages==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_cloak_links_pages' <?php if ($global_cloak_links_pages!=1){ echo 'checked="checked"'; } ?> value=0 > No 
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="This feature will cloak any live links found in the commenter's comment. THIS FEATURE SETTING IS BEST TURNED ON WHEN USED ALONG SIDE A CACHING PLUGIN."> 
							Cloak links in comments also?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_cloak_comments' <?php if ($global_cloak_comments==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_cloak_comments' <?php if ($global_cloak_comments!=1){ echo 'checked="checked"'; } ?> value=0 > No 
						
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Some commenters will leave a url to be associated with their name. THIS FEATURE SETTING IS BEST TURNED ON WHEN USED ALONG SIDE A CACHING PLUGIN."> 
							Cloak commenter's url?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_cloak_commenter_url' <?php if ($global_cloak_commenter_url==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_cloak_commenter_url' <?php if ($global_cloak_commenter_url!=1){ echo 'checked="checked"'; } ?> value=0 > No
						
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Adds rel='nofollow' to all outbound links."> 
							Nofollow sitewide cloaked links?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_nofollow_links' <?php if ($global_nofollow_links==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_nofollow_links' <?php if ($global_nofollow_links!=1){ echo 'checked="checked"'; } ?> value=0 > No 
						
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="If sitewide link cloaking is enabled, then this will be the default classification prefix for all auto-generated masked links."> 
							Default Classification Prefix
						</label>
					</td>
					<td>
						<select type=text  name='global_default_classification_prefix'>
						<?php
							foreach ($classification_prefix as $k=>$v)
							{
								if ($global_default_classification_prefix==$v)
								{
									$selected = "selected='true'";
								}
								else
								{
									$selected = '';
								}
								echo "<option value='$v' $selected>$v</option>";
							}
						?>
					</select>
					</td>
				</tr>				
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Only applicable if sitewide cloaking is turned on. This feature, if toggled on, will prevent non-human visitors from following outbound links."> 
							Filter and redirect spiders for sitewide link cloaking?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_redirect_spiders' <?php if ($global_redirect_spiders==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_redirect_spiders' <?php if ($global_redirect_spiders!=1){ echo 'checked="checked"'; } ?> value=0 > No
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Disabling this setting will prevent keword affects from taking place in your content. This can be used for troubleshooting. THIS FEATURE SETTING IS BEST TURNED ON WHEN USED ALONG SIDE A CACHING PLUGIN."> 
							Disable all keyword modification affects?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_keyword_affects' <?php if ($global_keyword_affects==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_keyword_affects' <?php if ($global_keyword_affects!=1){ echo 'checked="checked"'; } ?> value=0 > No 
					</td>
				</tr>
				<tr>
					<td colspan=2>
						<br><br>
					</td>
				</tr>
				<tr>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="WP Traffic Tools collects incomming search data from google. Use this feature to add a listing of the top incomming searches to the bottom of your posts. This may help boost performance for these keywords. "> 
							Display TopSearches at bottom of posts?
						</label>
					</td>
					<td>
						<input type=radio  size=67 name='global_topsearches' id='id_ts_1' <?php if ($global_topsearches==1){ echo 'checked="checked"'; } ?> value=1 > Yes &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio class='class_select_topsearches' id='id_ts_0' size=67 name='global_topsearches' <?php if ($global_topsearches!=1){ echo 'checked="checked"'; } ?> value=0 > No 
					</td>
				</tr>
				<tr class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Select Top Page Queries to show searches for the opened post, and select Global Queries to display site-wide queries."> 
							Topsearches Nature
						</label>
					</td>
					<td>
						<select type=text  name='global_topsearches_nature'>
							<option value='single' <?php if ($global_topsearches_nature=='single'){echo "selected='true'";}?>>Top Page Queries</option>
							<option value='global' <?php if ($global_topsearches_nature=='global'){echo "selected='true'";}?>>Global Queries</option>
					</select>
					</td>	
				</tr>
				<tr  class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="This content will appear above the listing of topsearches."> 
							Display Header
						</label>
					</td>
					<td>
						<input  class='class_select_topsearches' size=40 name='global_topsearches_header' value='<?php echo $global_topsearches_header; ?>' > 
					</td>
				</tr>
				<tr class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Select Top Page Queries to show searches for the opened post, and select Global Queries to display site-wide queries."> 
							Sorting
						</label>
					</td>
					<td>
						<select type=text  name='global_topsearches_sort'>
							<option value='DESC' <?php if ($global_topsearches_sort=='DESC'){echo "selected='true'";}?>>By Search Count: DESC</option>
							<option value='ASC' <?php if ($global_topsearches_sort=='ASC'){echo "selected='true'";}?>>By Search Count: ASC</option>
							<option value='RAND' <?php if ($global_topsearches_sort=='RAND'){echo "selected='true'";}?>>Randomize</option>
					</select>
					</td>	
				</tr>
				<tr class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Control the number of keywords displayed."> 
							Keyword Limit
						</label>
					</td>
					<td>
						<input class='class_select_topsearches' size=5 name='global_topsearches_limit' value='<?php echo $global_topsearches_limit; ?>' > 
					</td>
				</tr>
				<tr class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Toggle this to yes to turn keywords into links to respective posts. "> 
							Auto-Link Keywords
						</label>
					</td>
					<td>
						<input type=radio size=67 name='global_topsearches_link' <?php if ($global_topsearches_link!=1){ echo 'checked="checked"'; } ?> value=0 > Off &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_topsearches_link'  <?php if ($global_topsearches_link==1){ echo 'checked="checked"'; } ?> value=1 > On
					</td>
				</tr>
				<tr class='class_tr_topsearches_display'>
					<td>
						<label for=keyword>
						<img src="<?php echo WPTRAFFICTOOLS_URLPATH ?>images/tip.png" style="cursor:pointer;" border=0 title="Toggle this to yes to display # of times each keyword as been searched. "> 
							Display Search Count
						</label>
					</td>
					<td>
						<input type=radio size=67 name='global_topsearches_display_count' <?php if ($global_topsearches_display_count!=1){ echo 'checked="checked"'; } ?> value=0 > Off &nbsp;&nbsp;&nbsp;&nbsp;
						<input type=radio  size=67 name='global_topsearches_display_count'  <?php if ($global_topsearches_display_count==1){ echo 'checked="checked"'; } ?> value=1 > On
					</td>
				</tr>
				<tr>
					<td colspan=2>
						<br><br>
					</td>
				</tr>
				<tr>
					<td valign=top>
						<label for=keyword>
							<div>
								<img src="<?php echo WPTRAFFICTOOLS_URLPATH;; ?>images/tip.png" style="cursor:pointer;" border=0 title="WP Redirect will only redirect traffic containing these keywords in their useragent string. To redirect ALL traffic containing the propper keywords in their referrer then clear this list and add a *.">
								Permissable Useragents
								<br>
								<i> <font style='font-size:9px'>1 per line</font></i>
							</div>
							<br>
							<textarea name='useragents' rows='10' cols='50'><?php echo $useragents; ?></textarea>
						</label>
					</td>
					<td>	
							<div>
								<img src="<?php echo WPTRAFFICTOOLS_URLPATH;; ?>images/tip.png" style="cursor:pointer;" border=0 title="WP Redirect will not redirect any of these IP Addresses.">
								Blocked IPs
								<br>
								<i> <font style='font-size:9px'>1 per line</font></i>
							</div>
							<br>
							<textarea name='ip_addresses' rows=10 cols=50><?php echo $ip_addresses; ?></textarea>
					</td>
				</tr>
				<tr>
					<td>
						<button type=submit id='id_global_save_settings' name='save_global' value="Save" >Save Global Settings</button>
					</td>
				</tr>
			</table>
			</form>
		</div>
	<?php
}

function traffic_str_replace_once($remove , $replace , $string)
{
    //$remove = str_replace('/','\/',$remove);
    $return = preg_replace('/'.preg_quote($remove,'/').'/', $replace, $string, 1); 
	if (!$return)
	{
		echo "traffic_str_replace_once fail"; exit;
		echo "<br><br> Here is the string:<br><br>$string";  EXIT;
	}
    return $return;
}  

function traffic_get_string_between($string, $start, $end) 
{
	if (strstr($start,'%wildcard%'))
	{
		$start = str_replace("%wildcard%", ".*?", preg_quote($start, "/"));
	}
	else
	{
		$start = preg_quote($start, "/");
	}
	if (strstr($end,'%wildcard%'))
	{
		$end = str_replace("%wildcard%", ".*?", preg_quote($end, "/"));
	}
	else
	{
		//echo $end;exit;
		$end = preg_quote($end, "/");
		//echo $end; exit;
	}
    $regex = "/$start(.*?)$end/si";

	
    if (preg_match($regex, $string, $matches))
        return $matches[1];
    else
        return false;
}

function global_cloak_links($content, $nofollow, $redirect_spider, $global_cloak_links, $global_cloak_link_profiles)
{
	global $table_prefix;
	global $wordpress_url;
	
	if ($nofollow==1)
	{
		$nofollow = 'rel="nofollow"';
	}
	else
	{
		$nofollow = "";
	}
	
	if ($global_cloak_links==1)
	{
		$url_count = substr_count($content, "<a");
		$urls = array();
		$anchors = array();
		$replacement_urls = array();
		
		for ($ic = 0; $ic < $url_count; $ic++) 
		{
			$link_html = traffic_get_string_between($content, '<a', '</a>');
			//echo $link_html;exit;
			//determine urls
			if (!strstr($link_html, 'href="'))
			{		
				//echo '8'.$content; exit;	
			   $url_start = "href='";
			   $url_end = "'";
			}
			else
			{
				//echo '9'.$content; exit;	
				$url_start = 'href="';
				$url_end = '"';
			}
			
			
			$url = traffic_get_string_between($link_html, $url_start, $url_end);
			$remove = "$url_start$url$url_end";				
			$content = traffic_str_replace_once("<a{$link_html}</a>", "url[$ic]", $content);	
			$anchor = traffic_get_string_between($link_html.'</a>', '>', '</a>');
			$anchors[$ic] = $anchor;
			
			//echo $content;exit;
			if ($url&&!strstr($url,$wordpress_url))
			{
				
				//echo $anchor;exit;
				$url = str_replace(array('&amp;','&#38;'), '&', $url);
				//set original url into array
				$urls[] = $url;
				
				//determine if there is a pretty link for this url
				//get affiliate url
				
				
				$query = "SELECT * FROM {$table_prefix}wptt_cloakme_profiles WHERE redirect_url='$url' LIMIT 1";
				$result = mysql_query($query);
				if (!$result){echo $query; echo mysql_error(); exit;}
				$count = mysql_num_rows($result);
				
				if ($count>0)
				{
					//echo 1; exit;
					$arr = mysql_fetch_array($result);
					$cloaked_url = $arr['cloaked_url'];
					$permalink = $arr['permalink'];
					$replacement_urls[] = $cloaked_url;
					//echo $cloaked_url;exit;
				}
				else
				{	
					
					
					$anchor = sanitize_title_with_dashes( $anchor );
					if (strstr($anchor, 'http'))
					{
						$secret_phrase ="0123456789";
						$ref = str_shuffle($secret_phrase);
						$ref = substr($ref, 0, 4);
						$anchor = str_replace('http-','',$anchor);
						$anchor = str_replace('httpwww-','',$anchor);
						$anchor = explode('-',$anchor);
						$anchor =  $anchor[0].'-'.$ref;
					}
					if (!$anchor)
					{
						$secret_phrase ="linkcloakingwptraffictools0123456789";
						$ref = str_shuffle($secret_phrase);
						$anchor = substr($ref, 0, 7);
					}
					$replacement_urls[$ic] = $wordpress_url."go/$anchor";
					$cloaked_link = $wordpress_url."go/$anchor";
					
					//set cloaking data into tables
					$query = "INSERT INTO {$table_prefix}wptt_cloakme_profiles (`id`,`classification_prefix`,`permalink`,`cloaked_url`,`redirect_url`,`blank_referrer`,`redirect_spider`,`redirect_method`,`redirect_type`,`cloak_target`,`visitor_count`,`spider_count`,`type`)";
					$query .= "VALUES ('','go','$anchor','$cloaked_link','$url','0','$redirect_spider','none','301','0','0','0','global')";
					$result = mysql_query($query);
					if (!$result) 
					{
						//echo 2;exit;				//create unique reference id
						$secret_phrase ="linkcloakingwptraffictools";
						$ref = str_shuffle($secret_phrase);
						$ref = substr($ref, 0, 2);
						$replacement_urls[$ic] = $wordpress_url."go/{$ref}-{$anchor}";
						$cloaked_link = $wordpress_url."go/{$ref}-{$anchor}";
						//set cloaking data into tables
						$query = "INSERT INTO {$table_prefix}wptt_cloakme_profiles (`id`,`classification_prefix`,`permalink`,`cloaked_url`,`redirect_url`,`blank_referrer`,`redirect_spider`,`redirect_method`,`redirect_type`,`cloak_target`,`visitor_count`,`spider_count`,`type`)";
						$query .= "VALUES ('','go','{$ref}-{$anchor}','$cloaked_link','$url','0','$redirect_spider','none','301','0','0','0','global')";
						$result = mysql_query($query);
						if (!$result){ echo $query; echo mysql_error(); exit;}
					}
					
				}			
			}
			else
			{
				$replacement_urls[] = $url;
			}			
		}
		
		///exit;
		if ($replacement_urls)
		{
			foreach($replacement_urls as $key =>$value) 
			{
				//replace url with cloaked url
				$content = traffic_str_replace_once("url[$key]", "<a href='$value' $nofollow target='_blank'>$anchors[$key]</a>", $content);
			}
		}
	}
	if ($global_cloak_link_profiles==1&&$global_cloak_links!=1)
	{
		//echo 1; exit;
		$url_count = substr_count($content, "<a");
		$urls = array();
		$replacement_urls = array();
		
		for ($ic = 0; $ic < $url_count; $ic++) 
		{
			//echo $content; exit;		
			//determine urls
			if (!strstr($content, 'href="'))
			{		
			   $start = "href='";
			   $end = "'";
			}
			else
			{
				$start = 'href="';
				$end = '"';
			}
		
			$url = traffic_get_string_between($content, $start, $end);
			$remove = "$start$url$end";
			
			if ($url&&!strstr($url,$wordpress_url))
			{
				//replace with temp marker					
				$content = traffic_str_replace_once($remove, "url[$ic]", $content);		
							
				//set original url into array
				$urls[] = $url;
				
				$query = "SELECT * FROM {$table_prefix}wptt_cloakme_profiles WHERE redirect_url='$url' AND type='affiliate' LIMIT 1";
				$result = mysql_query($query);
				if (!$result){echo $query; echo mysql_error(); exit;}
				$count = mysql_num_rows($result);
				
				if ($count>0)
				{

					$arr = mysql_fetch_array($result);
					$cloaked_url = $arr['cloaked_url'];
					$permalink = $arr['permalink'];
					$replacement_urls[] = $cloaked_url;
					//echo $cloaked_url;exit;
				}
				else
				{	
					//echo 2;exit;				//create unique reference id
					$secret_phrase ="linkcloakingwptraffictools1234567890";
					$ref = str_shuffle($secret_phrase);
					$ref = substr($ref, 0, 9);
					$replacement_urls[] = $url;					
				}			
			}	
		}
		
		if ($replacement_urls)
		{
			foreach($replacement_urls as $key =>$value) 
			{
				//replace url with cloaked url
				$content = traffic_str_replace_once("url[$key]", "href='$value' $nofollow", $content);
			}
		}
	}
	//echo 1;exit;
    //echo $content; exit;
    return $content;

}

function global_cloak_links_filter($content)
{

	global $table_prefix;
	global $useragents;
	global $ip_addresses;
	global $global_cloak_links;
	global $global_cloak_links_pages;
	global $global_redirect_spiders;
	global $global_nofollow_links;
	global $global_cloak_link_profiles;
	global $global_keyword_affects;
	
	//echo is_page();exit;
	//echo $global_cloak_links_pages;exit;
	if ((is_page()||is_home())&&$global_cloak_links_pages==1)
	{
	}
	else
	{
		//echo $global_cloak_link_profiles;exit;
		if ($global_cloak_links==1||$global_cloak_link_profiles==1)
		{
			$content = global_cloak_links($content, $global_nofollow_links, $global_redirect_spiders, $global_cloak_links,$global_cloak_link_profiles);
		}
		
		if ($global_cloak_link_profiles==1)
		{
			//prepare auto-link keyword profiles
			$query = "SELECT id,cloaked_url,keywords,keywords_affect,keywords_limit, keywords_limit_total,keywords_target_page FROM {$table_prefix}wptt_cloakme_profiles WHERE keywords_affect>0";
			$result = mysql_query($query);
			if (!$result){echo $query; echo mysql_error(); exit;}
			$count = mysql_num_rows($result);

			if ($count>0)
			{
				while ($arr = mysql_fetch_array($result))
				{
					
					$target = $arr['keywords_target_page'];
					$keywords = explode(',',$arr['keywords']);
					$affect = $arr['keywords_affect'];
					$limit = $arr['keywords_limit'];
					$limit_total = $arr['keywords_limit_total'];
					$cloaked_url = $arr['cloaked_url'];
					$c = 0;
					$keys = array_keys($keywords);
					$size = sizeOf($keys);
					for ($key=0; $key<$size; $key++)
					{
					
						$i=0;
						$keywords[$key] = trim($keywords[$key]);
						
						//echo $limit_total;exit;
						if ($c<$limit_total)
						{
							if ($affect==1)
							{
								if (stristr($content,$keywords[$key])&&$i<$limit_total)
								{
									
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/i"," <a href='{$cloaked_url}' target='$target'>$keywords[$key]</a>", $content , $limit);
									$i++;
									$c++;
								}
							}
							if ($affect==2)
							{
								if (stristr($content,$keywords[$key])&&$i<=$limit_total)
								{
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/i"," <a href='{$cloaked_url}' rel='nofollow' target='$target'>$keywords[$key]</a>", $content , $limit);
									$i++;
									$c++;
								}
							}
							if ($affect==3)
							{
								if (strstr($content,$keywords[$key])&&$i<=$limit_total)
								{
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/"," <a href='{$cloaked_url}' target='$target'>$keywords[$key]</a>", $content , $limit);
									$i++;
									$c++;
								}
							}
							if ($affect==4)
							{
								if (strstr($content,$keywords[$key])&&$i<=$limit_total)
								{
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/s"," <a href='{$cloaked_url}' rel='nofollow' target='$target'>$keywords[$key]</a>", $content , $limit);
									$i++;
									$c++;
								}
							}
							if ($affect==5)
							{
								if (stristr($content,$keywords[$key])&&$i<=$limit_total)
								{
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/i"," <strong>$keywords[$key]</strong>", $content , $limit);
									$i++;
									$c++;
								}
							}
							if ($affect==6)
							{
								if (stristr($content,$keywords[$key])&&$i<=$limit_total)
								{
									$content = preg_replace("/(?<!_)(?<!-)\b$keywords[$key]\b(?!(.*?)\<\/h\d>)/i"," <i>$keywords[$key]</i>", $content , $limit);
									$i++;
									$c++;
								}
							}
						}
					}
				}
				
				
			}
		}
	}
	
	return $content;
}

function global_cloak_comments_filter($content)
{
	global $table_prefix;
	global $wordpress_url;
	global $useragents;
	global $ip_addresses;
	global $global_redirect_spiders;
	global $global_nofollow_links;
	global $global_cloak_link_profiles;
	global $global_keyword_affects;
	
	$url_count = substr_count($content, "<a");
	$urls = array();
	$replacement_urls = array();
	
	for ($ic = 0; $ic < $url_count; $ic++) 
	{
		//echo $content; exit;		
		//determine urls
		if (!strstr($content, 'href="'))
		{		
		   $start = "href='";
		   $end = "'";
		}
		else
		{
			$start = 'href="';
			$end = '"';
		}
	
		$url = traffic_get_string_between($content, $start, $end);
		$remove = "$start$url$end";
		
		if ($url&&!strstr($url,$wordpress_url))
		{
			//replace with temp marker					
			$content = traffic_str_replace_once($remove, "url[$ic]", $content);		
						
			//set original url into array
			$urls[] = $url;
			
			//determine if there is a pretty link for this url
			//get affiliate url
			
			
			$query = "SELECT * FROM {$table_prefix}wptt_cloakme_profiles WHERE redirect_url='$url' LIMIT 1";
			$result = mysql_query($query);
			if (!$result){echo $query; echo mysql_error(); exit;}
			$count = mysql_num_rows($result);
			
			if ($count>0)
			{

				$arr = mysql_fetch_array($result);
				$cloaked_url = $arr['cloaked_url'];
				$permalink = $arr['permalink'];
				$replacement_urls[] = $cloaked_url;
				//echo $cloaked_url;exit;
			}
			else
			{	
				
				//echo 2;exit;				//create unique reference id
				$secret_phrase ="linkcloakingwptraffictools1234567890";
				$ref = str_shuffle($secret_phrase);
				$ref = substr($ref, 0, 9);
				$replacement_urls[] = $wordpress_url."go/$ref";
				$cloaked_link = $wordpress_url."go/$ref";
				
				//set cloaking data into tables
				$query = "INSERT INTO {$table_prefix}wptt_cloakme_profiles (`id`,`classification_prefix`,`permalink`,`cloaked_url`,`redirect_url`,`blank_referrer`,`redirect_spider`,`redirect_method`,`redirect_type`,`cloak_target`,`visitor_count`,`spider_count`,`type`)";
				$query .= "VALUES ('','go','$ref','$cloaked_link','$url','0','$redirect_spider','none','301','0','0','0','global')";
				$result = mysql_query($query);
				if (!$result) { echo $query; echo mysql_error(); }
				
			}			
		}	
	}
	
	if ($replacement_urls)
	{
		foreach($replacement_urls as $key =>$value) 
		{
			//replace url with cloaked url
			$content = traffic_str_replace_once("url[$key]", "href='$value' $nofollow", $content);
		}
	}
	return $content;
}

function global_cloak_commenter_filter($url)
{
	global $table_prefix;
	global $useragents;
	global $ip_addresses;
	global $global_cloak_links;
	global $global_redirect_spiders;
	global $global_nofollow_links;
	global $global_cloak_link_profiles;
	global $global_keyword_affects;
	global $global_cloak_comments;
	global $wordpress_url;
		
	$query = "SELECT * FROM {$table_prefix}wptt_cloakme_profiles WHERE redirect_url='$url' LIMIT 1";
	$result = mysql_query($query);
	if (!$result){echo $query; echo mysql_error(); exit;}
	$count = mysql_num_rows($result);
			
	if ($count>0)
	{

		$arr = mysql_fetch_array($result);
		$cloaked_url = $arr['cloaked_url'];
		$permalink = $arr['permalink'];
		//echo $cloaked_url;exit;
	}
	else
	{	
		//echo 2;exit;				//create unique reference id
		$secret_phrase ="linkcloakingwptraffictools1234567890";
		$ref = str_shuffle($secret_phrase);
		$ref = substr($ref, 0, 9);
		$cloaked_url = $wordpress_url."go/$ref";
		
		//set cloaking data into tables
		$query = "INSERT INTO {$table_prefix}wptt_cloakme_profiles (`id`,`classification_prefix`,`permalink`,`cloaked_url`,`redirect_url`,`blank_referrer`,`redirect_spider`,`redirect_method`,`redirect_type`,`cloak_target`,`visitor_count`,`spider_count`,`type`)";
		$query .= "VALUES ('','go','$ref','$cloaked_url','$url','0','$redirect_spider','none','301','0','0','0','global')";
		$result = mysql_query($query);
		if (!$result) { echo $query; echo mysql_error(); }
		
	}	
	$url = $cloaked_url;
		
	return $url;
}

function wpt_add_top_searches($content)
{

	global $global_topsearches_nature;
	global $global_topsearches_header;
	global $global_topsearches_sort;
	global $global_topsearches_limit;
	global $global_topsearches_link;
	global $global_topsearches_display_count;
	//echo 1;
	//echo $global_topsearches_header;exit;
	$topsearches = "$global_topsearches_header <br>[wpttopsearches:$global_topsearches_nature:$global_topsearches_sort:$global_topsearches_limit:$global_topsearches_link:$global_topsearches_display_count]";
	$content = $content."<br><br>$topsearches";
	return $content;
}

function wpt_top_searches($content)
{
	if (strpos($content, 'wpttopsearches:'))
	{
		global $current_url;
		global $table_prefix;
		$post_id = url_to_postid($current_url);
		
		//echo $content;exit;
		
		preg_match_all('/wpttopsearches:(.*?)\]/',$content, $matches);
		$params  = explode(':',$matches[1][0]);
		//print_r($params);exit;
		$nature = $params[0];
		$sort = $params[1];
		$limit = $params[2];
		$display_count = $params[3];
		$link = $params[4];

		switch ($sort){
		case 'ASC':
			$sort = 'count ASC';
			break;
		case 'DESC':
			$sort = 'count DESC';
			break;
		case 'RAND':
			$sort = 'RAND()';
			break;
		}
		
		//echo $sort;exit;
		if ($nature=='single')
		{
			$query = "SELECT * FROM  {$table_prefix}wptt_wptraffictools_google WHERE post_id='$post_id' ORDER BY $sort LIMIT $limit";
			$result = mysql_query($query);
			$i=0;
			
			if (mysql_num_rows($result)>0)
			{
				$replace = "<ul class='topsearches'>";
			
				while(($arr = mysql_fetch_array($result))&&$i<$limit)
				{
					$keyword = $arr['keyword'];
					$count = $arr['count'];
					
					if ($count_display==1&&$link==1)
					{
						$replace .="<li><a href='$current_url'>$keyword ($count)</a></li>";
					}
					else if ($count_display==1&&$link!=1)
					{
						$replace .="<li>$keyword ($count)</li>";
					}
					else if ($count_display!=1&&$link==1)
					{
						$replace .="<li><a href='$current_url'>$keyword</a></li>";
					}
					else 
					{
						$keyword = str_replace("'", '"',$keyword);
						$replace .="<li>$keyword</li>";
					}
					
					$i++;
				}
				$replace .="</ul>";
			}
		}
		
		if ($nature=='global')
		{
			//echo 1; exit;
			$query = "SELECT * FROM  {$table_prefix}wptt_wptraffictools_google ORDER BY $sort LIMIT $limit";
			$result = mysql_query($query);
			$i=0;
			
			if (mysql_num_rows($result)>0)
			{
				$replace = "<ul class='topsearches'>";
			
				while(($arr = mysql_fetch_array($result))&&$i<$limit)
				{
					$keyword = $arr['keyword'];
					$count = $arr['count'];
					$permalink = $arr['permalink'];
					
					if ($count_display==1&&$link==1)
					{
						$replace .="<li><a href='$permalink' target='self'>$keyword ($count)</a></li>";
					}
					else if ($count_display==1&&$link!=1)
					{
						$replace .="<li>$keyword ($count)</li>";
					}
					else if ($count_display!=1&&$link==1)
					{
						$replace .="<li><a href='$permalink' target='self'>$keyword</a></li>";
					}
					else 
					{
						$replace .="<li>$keyword</li>";
					}
					
					$i++;
				}
				$replace .="</ul>";
			}
		}
		//echo $replace;exit;
		//echo $content;exit;
		$content =  preg_replace('/\[wpttopsearches:(.*?)\]/',$replace, $content);
		//echo $content;exit;
	}
	return $content;
}

if ($global_topsearches==1)
{
	add_filter('the_content','wpt_add_top_searches');
}

add_filter('the_content', 'wpt_top_searches');
add_filter('widget_text', 'wpt_top_searches');

add_filter('the_content', 'global_cloak_links_filter', 10 );
add_filter('the_content_rss', 'global_cloak_links_filter', 10);

if ($global_cloak_commenter_url==1)
{
	add_filter('get_comment_author_url_link', 'global_cloak_commenter_filter');
}

if ($global_cloak_comments==1)
{
	add_filter('comment_text', 'global_cloak_comments_filter');
	add_filter('comment_text_rss', 'global_cloak_comments_filter');
}

?>